//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdlib.h>
#include <math.h>
#include <gl\gl.h>
#pragma hdrstop

#include "DStruct.h"

#include "Geometry.cpp"

//---------------------------------------------------------------------------

#pragma package(smart_init)

int userbreak=0;

void glVertex3D(T3D v, double col) {
  glIndexd((GLdouble)col);
  glVertex4d((GLdouble)v[0],(GLdouble)v[1],(GLdouble)v[2],(GLdouble)v[3]);
};

double Eval(AnsiString s, int* index, double def, double* rnd) {
  if (((*index)+1>s.Length()) || (s[(*index)]!='(')) return def;
  if (s[(*index)+1]=='_') {
    (*index)+=2;
    double max=Eval(s,index,*rnd,rnd);
    double min=Eval(s,index,0,rnd);
    (*rnd)=(double)(random((int)(max-min+1))+min);
    return (*rnd);
  } else
  if (s[(*index)+1]=='~') {
    (*index)+=2;
    double mean=Eval(s,index,0,rnd);
    double stdev=Eval(s,index,1,rnd);
    (*rnd)=(double)RandG(mean,stdev);
    return (*rnd);
  } else
  if (s[(*index)+1]==':') {
    (*index)+=2;
    return (*rnd);
  } else {
    AnsiString ss="";
    while (((*index)+1<=s.Length())&&(s[(++(*index))]!=')')) ss+=s[*index];
    (*index)++;
    if ((*index)>s.Length()+1) return def;
    try {
      return StrToFloat(ss);
    }
    catch (const EConvertError&) {
      return def;
    }
  }
}


/////////////////////////////////////////////////////////

class TElement {
    T3D p;
    double col, wdh;
    int moveflag;
    TElement* next;
  public:
    TElement():next(0) {};
    ~TElement() {};
    void Assign3D(T3D pp) { Copy3D(p,pp); };
    void AssignCol(double ccol) { col=ccol; };
    void AssignWdh(double wwdh) { wdh=wwdh; };
  friend class TBuffer;
};

class TBuffer {
  private:
    TElement* start;
  public:
    TBuffer():start(0) {};
    ~TBuffer() { Clear(); };
    void Add(T3D, int, double, double);
    void Clear();
    void RefPoint(T3D& p) { if (!start) Zero3D(p); else Copy3D(p,start->p); };

    void Draw();
};

void TBuffer::Add(T3D xy, int mf, double col=19, double wdh=1) {
  if (!start) {
    start=new TElement();
    start->Assign3D(xy);
    start->AssignCol(col);
    start->AssignWdh(wdh);
    start->moveflag=mf;
  }
  else {
    TElement* behac=start;
    while (behac->next) behac=behac->next;
    behac->next=new TElement();
    behac->next->Assign3D(xy);
    behac->next->AssignCol(col);
    behac->next->AssignWdh(wdh);
    behac->next->moveflag=mf;
  }
};

void TBuffer::Clear() {
  TElement* behac=start;
  while (start) { start=start->next; delete behac; behac=start; }
  start=0;
};

void TBuffer::Draw() {
  if (start) {
    int poly=0;
    TElement* behac=start;
    glBegin(GL_LINE_STRIP);
    glVertex3D(behac->p,behac->col);
    while (behac->next) {
      behac=behac->next;
      switch (behac->moveflag) {
        case 0: if (!poly) {
                  glEnd();
                  glBegin(GL_LINE_STRIP);
                }
                glVertex3D(behac->p,behac->col); break;
        case 1: glVertex3D(behac->p,behac->col); break;
        case 2: glEnd(); glBegin(GL_POLYGON);
                glVertex3D(behac->p,behac->col);
                poly=1; break;
        case 3: poly=0;
                glEnd();
                glLineWidth(behac->wdh);
                glBegin(GL_LINE_STRIP);
                glVertex3D(behac->p,behac->col); break;
        case 4: if (!poly) {
                  glEnd();
                  glLineWidth(behac->wdh);
                  glBegin(GL_LINE_STRIP);
                  glVertex3D(behac->p,behac->col);
                } break;
      }
    }
    glEnd();
    glPointSize(3);
    glBegin(GL_POINTS);
    glVertex3D(start->p,19);
    glEnd();
    glPointSize(1);
  }
};

/////////////////////////////////////////////////////////

class TLSystem {
    TStringList* rules;
    AnsiString form;
    int mutend;
    int RandomMod(bool);
  public:
    TLSystem():form(""),mutend(0) { rules=new TStringList(); };
    ~TLSystem() { delete rules; };
    void Clear() { rules->Clear(); };
    void AssignRules(TStrings* rr) {
      rules->Assign(rr);
      mutend=rules->Count;
      for (int i=rules->Count-1; i>=0; i--)
        if (rules->Strings[i][1]=='+') mutend=i;
    };
    TStrings* Rules() {return rules; };
    void Execute(int, TProgressBar*);
    void Mutate(bool, int, int, int, int, int, int, int, int, int, int, int, int);
    AnsiString GetForm() { return form; };
};

void TLSystem::Execute(int it, TProgressBar* g) {
  AnsiString of, nf;
  TStringList* sr[256];
  int l, count;
  double rnd=1;
  for (int i=0; i<256; i++) sr[i]=new TStringList();
  for (int i=1; i<rules->Count; i++) {
    of=rules->Names[i];
    nf=rules->Strings[i].Delete(1,rules->Names[i].Length()+1);
    if (of[1]=='+') of=of.Delete(1,1);
    l=1;
    count=(int)Eval(of,&l,1,&rnd);
    for (int j=1; j<=count; j++) sr[(int)(of[l])]->Add(nf);
  }
  form=rules->Strings[0];
  if (it)
    for (int i=1; i<=it; i++) {
      nf="";
      g->Max=form.Length();
      g->Position=1;
      Application->ProcessMessages();
      for (int j=1; j<=form.Length(); j++) {
        if (!(sr[(int)form[j]]->Count))
          nf+=form[j];
        else
          nf+=sr[(int)form[j]]->Strings[random(sr[(int)form[j]]->Count)];
        if (!(j%50)) {
          g->Position=j; Application->ProcessMessages();
          if (userbreak) {
            userbreak=0;
            j=form.Length()+1;
            i=it+1;
          }
        }
      }
      form=nf;
    }
  for (int i=0; i<256; i++) delete sr[i];
};

int FindAfter(AnsiString ss, int after, char c) {
  if ((after>ss.Length())||(after<=0)) return 0;
  AnsiString tmp=ss.Delete(1,after-1);
  int result=tmp.Pos(c);
  if (!result) return 0;
  return (after+result-1);
}

char RandomDir() {
  switch (random(6)) {
    case 0: return '+';
    case 1: return '^';
    case 2: return '<';
    case 3: return '-';
    case 4: return '&';
    case 5: return '>';
  }
}

char RandomSize(char cc=' ') {
  switch (cc) {
    case ' ': switch (random(4)) {
                case 0: return 'H';
                case 1: return 'F';
                case 2: return 'f';
                case 3: return 'h';
              }
    case 'F': return 'H';
    case 'H': return 'F';
    case 'f': return 'h';
    case 'h': return 'f';

    case 'd': switch (random(2)) {
                case 0: return 'H';
                case 1: return 'F';
              }
  }
}

char RandomBracket(char cc=' ') {
  switch (cc) {
    case ' ': switch (random(2)) {
                case 0: return '{';
                case 1: return '[';
              }
    case '[': return '{';
    case '{': return '[';
    case ']': return '}';
    case '}': return ']';
  }
}

char OppositeBracket(char cc) {
  switch (cc) {
    case '[': return ']';
    case '{': return '}';
  }
}

int TLSystem::RandomMod(bool b) {
  if (b) return random(mutend);
  else return (random(mutend-1)+1);
}

void TLSystem::Mutate(bool b=true, int pis=0, int pas=0, int pad=0, int pds=0, int pdd=0, int pi=0, int pa=0, int pr=0, int pd=0, int pe=0, int ps=0, int pg=0) {
  if (!mutend) return;
  int max=1000;
  int i, j, k, ii;
  AnsiString tmp;
  char oldc, newc;
  int probsum=pis+pas+pad+pds+pdd+pi+pa+pr+pd+pe+ps+pg;
  int mut=random(probsum);
  int prob[12];
  prob[0] =pis;
  prob[1] =pis+pas;
  prob[2] =pis+pas+pad;
  prob[3] =pis+pas+pad+pds;
  prob[4] =pis+pas+pad+pds+pdd;
  prob[5] =pis+pas+pad+pds+pdd+pi;
  prob[6] =pis+pas+pad+pds+pdd+pi+pa;
  prob[7] =pis+pas+pad+pds+pdd+pi+pa+pr;
  prob[8] =pis+pas+pad+pds+pdd+pi+pa+pr+pd;
  prob[9] =pis+pas+pad+pds+pdd+pi+pa+pr+pd+pe;
  prob[10]=pis+pas+pad+pds+pdd+pi+pa+pr+pd+pe+ps;
  prob[11]=pis+pas+pad+pds+pdd+pi+pa+pr+pd+pe+ps+pg;

  if (mut<prob[0]) {
            newc=RandomSize('d'); //insert size
            j=RandomMod(b);
            if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
            else tmp=rules->Strings[j];
            k=random(tmp.Length()+1)+1;
            tmp=tmp.Insert(("["+(AnsiString)newc+"]"),k);
            if (j) tmp=rules->Names[j]+'='+tmp;
            rules->Strings[j]=tmp;
  } else

  if ((mut>=prob[0])&&(mut<prob[1])) {
            newc=RandomSize('d'); //"append" size
            j=RandomMod(b);
            if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
            else tmp=rules->Strings[j];
            k=random(tmp.Length()+1)+1;
            tmp=tmp.Insert(newc,k);
            if (j) tmp=rules->Names[j]+'='+tmp;
            rules->Strings[j]=tmp;
  } else


  if ((mut>=prob[1])&&(mut<prob[2])) {
            newc=RandomDir(); //"append" dir
            j=RandomMod(b);
            if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
            else tmp=rules->Strings[j];
            k=random(tmp.Length()+1)+1;
            tmp=tmp.Insert(newc,k);
            if (j) tmp=rules->Names[j]+'='+tmp;
            rules->Strings[j]=tmp;
  } else

  if ((mut>=prob[2])&&(mut<prob[3])) {
            oldc=RandomSize(); //delete size
            for (ii=0; ii<max; ii++) {
              j=RandomMod(b);
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=FindAfter(tmp,random(tmp.Length())+1,oldc);
              if (k) {
                tmp=tmp.Delete(k,1);
                if (j) {
                  tmp=rules->Names[j]+'='+tmp;
                  rules->Strings[j]=tmp;
                } else if (tmp!="") rules->Strings[j]=tmp;
                ii=max;
              }
            }
            for (ii=0; ii<mutend; ii++) {
              k=rules->Strings[ii].Pos("[]");
              while (k) {
                rules->Strings[ii]=rules->Strings[ii].Delete(k,2);
                k=rules->Strings[ii].Pos("[]");
              }
              k=rules->Strings[ii].Pos("{}");
              while (k) {
                rules->Strings[ii]=rules->Strings[ii].Delete(k,2);
                k=rules->Strings[ii].Pos("{}");
              }
            }
  } else

  if ((mut>=prob[3])&&(mut<prob[4])) {
            oldc=RandomDir(); //delete dir
            for (ii=0; ii<max; ii++) {
              j=RandomMod(b);
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=FindAfter(tmp,random(tmp.Length())+1,oldc);
              if (k) {
                tmp=tmp.Delete(k,1);
                if (j) {
                  tmp=rules->Names[j]+'='+tmp;
                  rules->Strings[j]=tmp;
                } else if (tmp!="") rules->Strings[j]=tmp;
                ii=max;
              }
            }
            for (ii=0; ii<mutend; ii++) {
              k=rules->Strings[ii].Pos("[]");
              while (k) {
                rules->Strings[ii]=rules->Strings[ii].Delete(k,2);
                k=rules->Strings[ii].Pos("[]");
              }
              k=rules->Strings[ii].Pos("{}");
              while (k) {
                rules->Strings[ii]=rules->Strings[ii].Delete(k,2);
                k=rules->Strings[ii].Pos("{}");
              }
            }
  } else

  if ((mut>=prob[4])&&(mut<prob[5])) {
            i=random(rules->Count-1)+1; //insert
            j=RandomMod(b);
            if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
            else tmp=rules->Strings[j];
            k=random(tmp.Length()+1)+1;
            tmp=tmp.Insert(("[" +(AnsiString)rules->Names[i][rules->Names[i].Length()]+"]"),k);
            if (j) tmp=rules->Names[j]+'='+tmp;
            rules->Strings[j]=tmp;
  } else

  if ((mut>=prob[5])&&(mut<prob[6])) {
            i=random(rules->Count-1)+1; //"append"
            j=RandomMod(b);
            if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
            else tmp=rules->Strings[j];
            k=random(tmp.Length()+1)+1;
            tmp=tmp.Insert((rules->Names[i][rules->Names[i].Length()]),k);
            if (j) tmp=rules->Names[j]+'='+tmp;
            rules->Strings[j]=tmp;
  } else

  if ((mut>=prob[6])&&(mut<prob[7])) {
            i=random(rules->Count-1)+1; //replace
            j=random(rules->Count-1)+1;
            oldc=rules->Names[i][rules->Names[i].Length()];
            newc=rules->Names[j][rules->Names[j].Length()];
            for (ii=0; ii<max; ii++) {
              j=RandomMod(b);
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=FindAfter(tmp,random(tmp.Length())+1,oldc);
              if (k) {
                tmp[k]=newc;
                if (j) tmp=rules->Names[j]+'='+tmp;
                rules->Strings[j]=tmp;
                ii=max;
              }
            }
  } else

  if ((mut>=prob[7])&&(mut<prob[8])) {
            i=random(rules->Count-1)+1; //delete
            oldc=rules->Names[i][rules->Names[i].Length()];
            for (ii=0; ii<max; ii++) {
              j=RandomMod(b);
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=FindAfter(tmp,random(tmp.Length())+1,oldc);
              if (k) {
                tmp=tmp.Delete(k,1);
                if (j) {
                  tmp=rules->Names[j]+'='+tmp;
                  rules->Strings[j]=tmp;
                } else if (tmp!="") rules->Strings[j]=tmp;
                ii=max;
              }
            }
            for (ii=0; ii<mutend; ii++) {
              k=rules->Strings[ii].Pos("[]");
              while (k) {
                rules->Strings[ii]=rules->Strings[ii].Delete(k,2);
                k=rules->Strings[ii].Pos("[]");
              }
              k=rules->Strings[ii].Pos("{}");
              while (k) {
                rules->Strings[ii]=rules->Strings[ii].Delete(k,2);
                k=rules->Strings[ii].Pos("{}");
              }
            }
  } else

  if ((mut>=prob[8])&&(mut<prob[9])) {
            for (ii=0; ii<max; ii++) { //swap dirs
              j=RandomMod(b);
              oldc=RandomDir(); newc=RandomDir();
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=FindAfter(tmp,random(tmp.Length())+1,oldc);
              if (k) {
                tmp[k]=newc;
                if (j) tmp=rules->Names[j]+'='+tmp;
                rules->Strings[j]=tmp;
                ii=max;
              }
            }
  } else

  if ((mut>=prob[9])&&(mut<prob[10])) {
            for (ii=0; ii<max; ii++) { //swap sizes
              j=RandomMod(b);
              oldc=RandomSize(); newc=RandomSize(oldc);
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=FindAfter(tmp,random(tmp.Length())+1,oldc);
              if (k) {
                tmp[k]=newc;
                if (j) tmp=rules->Names[j]+'='+tmp;
                rules->Strings[j]=tmp;
                ii=max;
              }
            }
  } else

  if ((mut>=prob[10])&&(mut<prob[11])) {
            for (ii=0; ii<max; ii++) { //growths
              j=RandomMod(b);
              oldc=RandomBracket(); newc=RandomBracket(oldc);
              if (j) tmp=rules->Strings[j].Delete(1,rules->Names[j].Length()+1);
              else tmp=rules->Strings[j];
              k=tmp.Pos(oldc); if (k) ii=max;
              while (k) {
                tmp[k]=newc;
                k=tmp.Pos(oldc);
              }
              oldc=OppositeBracket(oldc); newc=RandomBracket(oldc);
              k=tmp.Pos(oldc); if (k) ii=max;
              while (k) {
                tmp[k]=newc;
                k=tmp.Pos(oldc);
              }
              if (j) tmp=rules->Names[j]+'='+tmp;
              rules->Strings[j]=tmp;
            }
  }
};

////////////////////////////////////////////////////////

class T3DElement {
    T3D info;
    T3DElement* next;
  public:
    T3DElement():next(0) {};
    ~T3DElement() {};
    void AssignInfo(T3D p) { Copy3D(info,p); };
  friend class T3DStack;
};

class T3DStack {
    T3DElement* start;
  public:
    T3DStack():start(0) {};
    ~T3DStack();
    void Push(T3D);
    int Pop(T3D&);
    void Clear();
};

T3DStack::~T3DStack() {
 Clear();
};

void T3DStack::Push(T3D p) {
  T3DElement* tmp=new T3DElement();
  tmp->AssignInfo(p);
  if (!start) start=tmp;
  else {
    tmp->next=start; start=tmp;
  }
};

void T3DStack::Clear() {
  T3DElement* behac=start;
  while (start) { start=start->next; delete behac; behac=start; }
};

int T3DStack::Pop(T3D& p) {
  if (!start) return 0;
  T3DElement* behac=start->next;
  Copy3D(p,start->info);
  delete start; start=behac;
  return 1;
};

class TFTurtle {
    T3D p,x,y,z;
    T3DStack* stack;
    T3DStack* pstack;
    void Forward(double);
    void HeadLeft(double);
    void HeadRight(double);
    void PitchUp(double);
    void PitchDown(double);
    void RollLeft(double);
    void RollRight(double);
    void PackParams(T3D&);
    void UnpackParams(T3D);
  public:
    double spd;
    double trn;
    double col;
    double wdh;
    TFTurtle();
    ~TFTurtle() { delete stack; delete pstack; };
    void SetPosition(T3D pp) { Copy3D(p,pp); };
    void SetPosition(double xx, double yy, double zz) { Set3D(p,xx,yy,zz,1); };
    void Execute(AnsiString, TBuffer*, TProgressBar*);
};

TFTurtle::TFTurtle() {
  Zero3D(p);
  Set3D(x,1,0,0,1);
  Set3D(y,0,1,0,1);
  Set3D(z,0,0,1,1);
  HeadLeft(90);
  PitchUp(90);
  stack=new T3DStack();
  pstack=new T3DStack();
  spd=10;
  trn=45;
  col=19;
  wdh=1;
};

void TFTurtle::Forward(double sspd) {
  T3D tmp;
  Copy3D(tmp,x);
  Mpy3D(tmp,sspd);
  Add3D(p,tmp);
};

void TFTurtle::HeadLeft(double ttrn) {
  TMatrix m;
  Identity(m);
  RotateDOrigin(m,ttrn,y);
  Transform3D(x,m); //Normalize3D(x);
  Transform3D(z,m);
};

void TFTurtle::HeadRight(double ttrn) {
  TMatrix m;
  Identity(m);
  RotateDOrigin(m,-ttrn,y);
  Transform3D(x,m); //Normalize3D(x);
  Transform3D(z,m);
};

void TFTurtle::PitchUp(double ttrn) {
  TMatrix m;
  Identity(m);
  RotateDOrigin(m,ttrn,z);
  Transform3D(x,m); //Normalize3D(x);
  Transform3D(y,m);
};

void TFTurtle::PitchDown(double ttrn) {
  TMatrix m;
  Identity(m);
  RotateDOrigin(m,-ttrn,z);
  Transform3D(x,m); //Normalize3D(x);
  Transform3D(y,m);
};

void TFTurtle::RollLeft(double ttrn) {
  TMatrix m;
  Identity(m);
  RotateDOrigin(m,-ttrn,x);
  Transform3D(y,m);
  Transform3D(z,m);
};

void TFTurtle::RollRight(double ttrn) {
  TMatrix m;
  Identity(m);
  RotateDOrigin(m,ttrn,x);
  Transform3D(y,m);
  Transform3D(z,m);
};


void TFTurtle::PackParams(T3D& p) {
  Set3D(p,spd,trn,col,wdh);
};

void TFTurtle::UnpackParams(T3D p) {
  spd=p[0];
  trn=p[1];
  col=p[2];
  wdh=p[3];
};

void TFTurtle::Execute(AnsiString chain, TBuffer* f, TProgressBar* g) {
  int mod=1;
  g->Max=chain.Length();
  g->Position=1;

  T3D tmp;
  T3D bp, bx, by, bz, bpr;
  double rnd=0;
  double tmpd1,tmpd2;
  spd=10;
  trn=45;
  col=19;
  wdh=1;
  stack->Clear(); pstack->Clear();

  Copy3D(bp,p); Copy3D(bx,x); Copy3D(by,y); Copy3D(bz,z); PackParams(bpr);
  f->Add(p,1,col);
  int i=1;
  while (i<=chain.Length()) {
    switch (chain[i++]) {
      case 'F': Forward(Eval(chain,&i,spd,&rnd)); f->Add(p,1,col); break;
      case 'f': Forward(Eval(chain,&i,spd,&rnd)); f->Add(p,0,col); break;
      case 'H': Forward(Eval(chain,&i,spd/2.0,&rnd)); f->Add(p,1,col); break;
      case 'h': Forward(Eval(chain,&i,spd/2.0,&rnd)); f->Add(p,0,col); break;
      case 'G': f->Add(p,1,col); break;
      case 'g': Forward(Eval(chain,&i,spd,&rnd)); break;


      case '+': HeadLeft(Eval(chain,&i,trn,&rnd)); break;
      case '-': HeadRight(Eval(chain,&i,trn,&rnd));break;
      case '^': PitchUp(Eval(chain,&i,trn,&rnd)); break;
      case '&': PitchDown(Eval(chain,&i,trn,&rnd)); break;
      case '<': RollLeft(Eval(chain,&i,trn,&rnd)); break;
      case '>': RollRight(Eval(chain,&i,trn,&rnd)); break;
      case '|': HeadLeft(180); break;
      case '%': RollLeft(180); break;

      case '[': PackParams(tmp); stack->Push(tmp);
                stack->Push(z); stack->Push(y); stack->Push(x); stack->Push(p); break;
      case ']': if (!stack->Pop(p)) break;
                stack->Pop(x); stack->Pop(y); stack->Pop(z);
                stack->Pop(tmp); UnpackParams(tmp);
                f->Add(p,4,col,wdh); break;
      case '{': PackParams(tmp); pstack->Push(tmp);
                pstack->Push(z); pstack->Push(y); pstack->Push(x); pstack->Push(p);
                f->Add(p,2,col); break;
      case '}': if (!pstack->Pop(p)) break;
                pstack->Pop(x); pstack->Pop(y); pstack->Pop(z);
                pstack->Pop(tmp); UnpackParams(tmp);
                f->Add(p,3,col,wdh); break;

      case '!': spd=Eval(chain,&i,spd,&rnd); break;
      case '?': trn=Eval(chain,&i,trn,&rnd); break;
      case '.': col=Eval(chain,&i,(double)(((int)col+1)%20),&rnd); break;

      case '*': spd*=Eval(chain,&i,1,&rnd); break;
      case '#': spd+=Eval(chain,&i,0,&rnd); break;
      case '@': trn*=Eval(chain,&i,1,&rnd); break;
      case '/': trn+=Eval(chain,&i,0,&rnd); break;

      case '$': wdh=Eval(chain,&i,wdh,&rnd); f->Add(p,4,col,wdh); break;
      case '\'': wdh*=Eval(chain,&i,1,&rnd); f->Add(p,4,col,wdh); break;
      case '\"': wdh+=Eval(chain,&i,0,&rnd); f->Add(p,4,col,wdh); break;

      case '_': tmpd2=Eval(chain,&i,rnd,&rnd);
                tmpd1=Eval(chain,&i,0,&rnd);
                rnd=(double)(random((int)(tmpd2-tmpd1+1))+tmpd1);
                break;
      case '~': tmpd1=Eval(chain,&i,0,&rnd);
                tmpd2=Eval(chain,&i,1,&rnd);
                rnd=(double)RandG(tmpd1,tmpd2);
                break;
    }
    if (--mod<=0) {
      g->Position=i; Application->ProcessMessages();
      mod=50;
      if (userbreak) {
        userbreak=0;
        i=chain.Length()+1;
      }
    }
  }
  Copy3D(p,bp); Copy3D(x,bx); Copy3D(y,by); Copy3D(z,bz); UnpackParams(bpr);
};

////////////////////////////////////////////////////////

class TFractal {
  private:
    TLSystem* lsys;
    TFTurtle* ltur;
    TBuffer* lbuf;
    int empty;
  public:
    TFractal() { lsys=new TLSystem(); ltur=new TFTurtle(); lbuf=new TBuffer(); empty=1; };
    ~TFractal() { delete lsys; delete ltur; delete lbuf; };

    void Clear() { lsys->Clear(); lbuf->Clear(); empty=0; };

    void SetPos(double x=0, double y=0, double z=0) { ltur->SetPosition(x,y,z); };

    void SetUp(TStrings* rr) { lsys->AssignRules(rr); empty=0; };
    void Display(TStrings* rr) { rr->Assign(lsys->Rules()); };

    void Compute(int i, TProgressBar* g) { if (empty) return; lbuf->Clear(); lsys->Execute(i,g); ltur->Execute(lsys->GetForm(),lbuf,g); };
    void Mutate(bool b, int is, int as, int ad, int ds, int dd, int i, int a, int r, int d, int e, int s, int g) { if (empty) return; lsys->Mutate(b,is,as,ad,ds,dd,i,a,r,d,e,s,g); };
    void Draw() { lbuf->Draw(); };

    void RefPoint(T3D& p) { lbuf->RefPoint(p); };
    AnsiString GetForm() { return lsys->GetForm(); };

    int Empty() { return empty; };
};

void Break() { userbreak=1; };

