//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "OpenGLPanel"
#pragma link "CSPIN"
#pragma resource "*.dfm"

#include "DStruct.cpp"

TForm1 *Form1;

int x,y;

int reset=0;

double rotx=0;
double roty=0;
double rotz=0;

double trnx=0;
double trny=0;
double trnz=0;

double sclx=0;
double scly=0;
double sclz=0;


TFractal* f=0;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  f=new TFractal();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  delete f;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::CSpinEditISExit(TObject *Sender)
{
  if (StrToIntDef(((TCSpinEdit*)Sender)->Text,MaxInt)==MaxInt)
    ((TCSpinEdit*)Sender)->Value=((TCSpinEdit*)Sender)->MinValue;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::gInit(TObject *Sender)
{
  glViewport(0, 0, (GLsizei)g->Width, (GLsizei)g->Height);

 	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

  //glFrustum(-300.0, 300.0, -300.0, 300.0, 1, 600.0);
  gluPerspective(45,g->Width/g->Height,1,2001);
  glTranslated(0,0,-1000);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glScaled(10,10,10);
  glTranslated(0,-20,0);

  glPushMatrix();
  glDisable(GL_LINE_SMOOTH);

  glShadeModel(GL_FLAT);
  glClearColor(0.0f,0.0f,0.0f,1.0f);
  glEnable(GL_DEPTH_TEST);
  glDepthFunc(GL_LEQUAL);
  glClearDepth(1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::gPaint(TObject *Sender)
{
  T3D tmp={0,0,0,1};
  if (f) f->RefPoint(tmp);
  if ((trnx!=0)||(trny!=0)||(trnz!=0)) {
    glTranslated(trnx,trny,trnz);
    trnx=trny=trnz=0;
  }
  if ((rotx!=0)||(roty!=0)||(rotz!=0)) {
    glTranslated((GLdouble)tmp[0],(GLdouble)tmp[1],(GLdouble)tmp[2]);
    glRotated(rotx,1,0,0);
    glRotated(roty,0,1,0);
    glRotated(rotz,0,0,1);
    glTranslated(-(GLdouble)tmp[0],-(GLdouble)tmp[1],-(GLdouble)tmp[2]);
    rotx=roty=rotz=0;
  }
  if ((sclx!=0)||(scly!=0)||(sclz!=0)) {
    glTranslated((GLdouble)tmp[0],(GLdouble)tmp[1],(GLdouble)tmp[2]);
    glScaled(sclx+1,scly+1,sclz+1);
    glTranslated(-(GLdouble)tmp[0],-(GLdouble)tmp[1],-(GLdouble)tmp[2]);
    sclx=scly=sclz=0;
  }

  if (reset) { glPopMatrix(); glPushMatrix(); reset=0; }
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glColor3f(1,1,1);

  f->Draw();

  glFlush();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::gMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
  if (Shift.Contains(ssShift)) {
    if (Shift.Contains(ssLeft)) {
      if (SpeedButtonX->Down) trnx=X-x;
      if (SpeedButtonY->Down) trny=y-Y;
      if (SpeedButtonZ->Down) trnz=Y-y;
      g->Refresh();
    }
/*    else if (Shift.Contains(ssRight)) {
      g->Refresh();
    }*/
  } else

  if (Shift.Contains(ssCtrl)) {
    if (Shift.Contains(ssLeft)) {
      if (SpeedButtonX->Down) rotx=Y-y;
      if (SpeedButtonY->Down) roty=X-x;
      if (SpeedButtonZ->Down) rotz=X-x;
      g->Refresh();
    }
/*    else if (Shift.Contains(ssRight)) {
      g->Refresh();
    }*/
  } else

  if (Shift.Contains(ssAlt)) {
    if (Shift.Contains(ssLeft)) {
      double tmp=(double)(Y-y)*0.005;
      if (SpeedButtonX->Down) sclx=tmp;
      if (SpeedButtonY->Down) scly=tmp;
      if (SpeedButtonZ->Down) sclz=tmp;
      g->Refresh();
    }
  /*    else if (Shift.Contains(ssRight)) {
      g->Refresh();
    }*/
  } /*else

  if (Shift.Contains(ssLeft)) {
    g->Refresh();
  } else

  if (Shift.Contains(ssRight)) {
    g->Refresh();
  }*/

  x=X;
  y=Y;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonResetClick(TObject *Sender)
{
  reset=1;
  g->Refresh();
}
//---------------------------------------------------------------------------



void __fastcall TForm1::ButtonDrawClick(TObject *Sender)
{
  GroupBoxProg->Visible=true;
  f->Clear();
  f->SetUp(MemoRules->Lines);
  f->Compute(CSpinEditIter->Value,ProgressBar);
  EditForm->Text=f->GetForm();
  g->Refresh();
  GroupBoxProg->Visible=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonMutClick(TObject *Sender)
{
  f->Clear();
  f->SetUp(MemoRules->Lines);
  f->Mutate(CheckBoxAxMut->Checked,CSpinEditIS->Value,CSpinEditAS->Value,CSpinEditAD->Value,CSpinEditDS->Value,CSpinEditDD->Value,CSpinEditI->Value,CSpinEditA->Value,CSpinEditR->Value,CSpinEditD->Value,CSpinEditE->Value,CSpinEditS->Value,CSpinEditG->Value);
  f->Display(MemoRules->Lines);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonMutDrwClick(TObject *Sender)
{
  GroupBoxProg->Visible=true;
  f->Clear();
  f->SetUp(MemoRules->Lines);
  f->Mutate(CheckBoxAxMut->Checked,CSpinEditIS->Value,CSpinEditAS->Value,CSpinEditAD->Value,CSpinEditDS->Value,CSpinEditDD->Value,CSpinEditI->Value,CSpinEditA->Value,CSpinEditR->Value,CSpinEditD->Value,CSpinEditE->Value,CSpinEditS->Value,CSpinEditG->Value);
  f->Display(MemoRules->Lines);
  f->Compute(CSpinEditIter->Value,ProgressBar);
  EditForm->Text=f->GetForm();
  g->Refresh();
  GroupBoxProg->Visible=false;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ButtonLoadClick(TObject *Sender)
{
  if (OpenDialog->Execute()) {
    MemoRules->Lines->LoadFromFile(OpenDialog->FileName);
    CSpinEditIter->Value=StrToIntDef(MemoRules->Lines->Strings[0],5);
    MemoRules->Lines->Delete(0);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSaveClick(TObject *Sender)
{
  if (SaveDialog->Execute()) {
    MemoRules->Lines->Insert(0,IntToStr(CSpinEditIter->Value));
    MemoRules->Lines->SaveToFile(SaveDialog->FileName);
    MemoRules->Lines->Delete(0);
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonStopClick(TObject *Sender)
{
  Break();  
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ButtonSaveImgClick(TObject *Sender)
{
  if (SavePictureDialog->Execute())
    g->SaveOpenGLPanelToFile(SavePictureDialog->FileName);
}
//---------------------------------------------------------------------------

